

#include <iostream>

using namespace std;

class myInt
{
	int value;

public:
	myInt(int v) { value = (v<100 && v >= 0 ? v : -1); }
	void setValue(int v) { value = (v<100 && v >= 0 ? v : -1); }
	int getValue() { return value; }

	friend ostream& operator<<(ostream&, myInt&);

	friend myInt& operator+(myInt&, int);
	friend myInt& operator-(myInt&, int);
	friend myInt& operator+(int, myInt&);
	friend myInt& operator-(int, myInt&);

	//a solution:
	//friend double& operator+(double, myInt&);

	myInt& operator+(myInt& other)
	{
		myInt* ans = new myInt(value + other.value);
		return *ans;
	}

	myInt& operator-(myInt& other)
	{
		myInt* ans = new myInt(value - other.value);
		return *ans;
	}
};

ostream& operator<<(ostream& os, myInt& i)
{
	os << i.value;
	return os;
}

myInt& operator+(myInt& l, int r)
{
	myInt* ans = new myInt(l.value + r);
	return *ans;
}

myInt& operator-(myInt& l, int r)
{
	myInt* ans = new myInt(l.value - r);
	return *ans;
}

myInt& operator+(int l, myInt& r)
{
	myInt* ans = new myInt(l + r.value);
	return *ans;
}

myInt& operator-(int l, myInt& r)
{
	myInt* ans = new myInt(l - r.value);
	return *ans;
}

/*
double& operator+(double l, myInt& r)
{
double* ans = new double(l+r.value);
return *ans;
}
*/



void main()
{
	myInt i(5), j(10);

	cout << i << " " << j << endl;
	cout << i + j << endl;
	cout << 100 + i << endl;
	cout << j + 500 << endl;

	cout << 10.05 + i << endl;
	cout << j + 5.8 << endl;

	system("pause");
}

