/*
oop_ex92.cpp: user-defined conversion
vs. oop_ex91.cpp
*/


#include <iostream>

using namespace std;

class myInt
{
	int value;

public:
	myInt(int v) { value = (v<100 && v >= 0 ? v : -1); }
	void setValue(int v) { value = (v<100 && v >= 0 ? v : -1); }
	int getValue() { return value; }

	friend ostream& operator<<(ostream&, myInt&);

	operator int() { cout << "to int" << endl; return value; }
	//operator double(){ cout<<"to double"<<endl; return value; }	//will cause ambiguous call

	//no need to (sometimes can't) provide overloaded operators 
};

ostream& operator<<(ostream& os, myInt& i)
{
	os << i.value;
	return os;
}




void main()
{
	myInt i(5), j(10);

	cout << i << " " << j << endl;
	cout << i + j << endl;
	cout << 100 + i << endl;
	cout << j + 500 << endl;

	cout << 10.05 + i << endl;
	cout << j + 5.8 << endl;

	cout << (int)i << endl;

	system("pause");
}

